diff --git a/hw/i386/pc_piix.c b/hw/i386/pc_piix.c
index 47546b7..d8010d16 100644
--- a/hw/i386/pc_piix.c
+++ b/hw/i386/pc_piix.c
@@ -441,6 +441,9 @@ static QEMUMachine pc_i440fx_machine_v2_1 = {
     .is_default = 1,
 };
 
+#define PC_I440FX_COMPAT_2_0 \
+    PC_COMPAT_2_0
+
 #define PC_I440FX_2_0_MACHINE_OPTIONS PC_I440FX_2_1_MACHINE_OPTIONS
 
 static QEMUMachine pc_i440fx_machine_v2_0 = {
@@ -448,11 +451,15 @@ static QEMUMachine pc_i440fx_machine_v2_0 = {
     .name = "pc-i440fx-2.0",
     .init = pc_init_pci_2_0,
     .compat_props = (GlobalProperty[]) {
-        PC_COMPAT_2_0,
+        PC_I440FX_COMPAT_2_0,
         { /* end of list */ }
     },
 };
 
+#define PC_I440FX_COMPAT_1_7 \
+    PC_I440FX_COMPAT_2_0, \
+    PC_COMPAT_1_7
+
 #define PC_I440FX_1_7_MACHINE_OPTIONS PC_I440FX_MACHINE_OPTIONS
 
 static QEMUMachine pc_i440fx_machine_v1_7 = {
@@ -460,11 +467,15 @@ static QEMUMachine pc_i440fx_machine_v1_7 = {
     .name = "pc-i440fx-1.7",
     .init = pc_init_pci_1_7,
     .compat_props = (GlobalProperty[]) {
-        PC_COMPAT_1_7,
+        PC_I440FX_COMPAT_1_7,
         { /* end of list */ }
     },
 };
 
+#define PC_I440FX_COMPAT_1_6 \
+    PC_I440FX_COMPAT_1_7, \
+    PC_COMPAT_1_6
+
 #define PC_I440FX_1_6_MACHINE_OPTIONS PC_I440FX_MACHINE_OPTIONS
 
 static QEMUMachine pc_i440fx_machine_v1_6 = {
@@ -472,21 +483,29 @@ static QEMUMachine pc_i440fx_machine_v1_6 = {
     .name = "pc-i440fx-1.6",
     .init = pc_init_pci_1_6,
     .compat_props = (GlobalProperty[]) {
-        PC_COMPAT_1_6,
+        PC_I440FX_COMPAT_1_6,
         { /* end of list */ }
     },
 };
 
+#define PC_I440FX_COMPAT_1_5 \
+    PC_I440FX_COMPAT_1_6, \
+    PC_COMPAT_1_5
+
 static QEMUMachine pc_i440fx_machine_v1_5 = {
     PC_I440FX_1_6_MACHINE_OPTIONS,
     .name = "pc-i440fx-1.5",
     .init = pc_init_pci_1_5,
     .compat_props = (GlobalProperty[]) {
-        PC_COMPAT_1_5,
+        PC_I440FX_COMPAT_1_5,
         { /* end of list */ }
     },
 };
 
+#define PC_I440FX_COMPAT_1_4 \
+    PC_I440FX_COMPAT_1_5, \
+    PC_COMPAT_1_4
+
 #define PC_I440FX_1_4_MACHINE_OPTIONS \
     PC_I440FX_1_6_MACHINE_OPTIONS, \
     .hot_add_cpu = NULL
@@ -496,13 +515,13 @@ static QEMUMachine pc_i440fx_machine_v1_4 = {
     .name = "pc-i440fx-1.4",
     .init = pc_init_pci_1_4,
     .compat_props = (GlobalProperty[]) {
-        PC_COMPAT_1_4,
+        PC_I440FX_COMPAT_1_4,
         { /* end of list */ }
     },
 };
 
 #define PC_COMPAT_1_3 \
-	PC_COMPAT_1_4, \
+	PC_I440FX_COMPAT_1_4, \
         {\
             .driver   = "usb-tablet",\
             .property = "usb_version",\
diff --git a/hw/i386/pc_q35.c b/hw/i386/pc_q35.c
index c640e7b..57eecc3 100644
--- a/hw/i386/pc_q35.c
+++ b/hw/i386/pc_q35.c
@@ -383,8 +383,8 @@ static QEMUMachine pc_q35_machine_v2_0 = {
 };
 
 #define PC_Q35_COMPAT_1_7 \
-        PC_COMPAT_1_7, \
         PC_Q35_COMPAT_2_0, \
+        PC_COMPAT_1_7, \
         {\
             .driver   = "hpet",\
             .property = HPET_INTCAP,\
@@ -404,8 +404,8 @@ static QEMUMachine pc_q35_machine_v1_7 = {
 };
 
 #define PC_Q35_COMPAT_1_6 \
-        PC_COMPAT_1_6, \
-        PC_Q35_COMPAT_1_7
+        PC_Q35_COMPAT_1_7, \
+        PC_COMPAT_1_6
 
 #define PC_Q35_1_6_MACHINE_OPTIONS PC_Q35_MACHINE_OPTIONS
 
@@ -420,8 +420,8 @@ static QEMUMachine pc_q35_machine_v1_6 = {
 };
 
 #define PC_Q35_COMPAT_1_5 \
-        PC_COMPAT_1_5, \
-        PC_Q35_COMPAT_1_6
+        PC_Q35_COMPAT_1_6, \
+        PC_COMPAT_1_5
 
 static QEMUMachine pc_q35_machine_v1_5 = {
     PC_Q35_1_6_MACHINE_OPTIONS,
@@ -434,8 +434,8 @@ static QEMUMachine pc_q35_machine_v1_5 = {
 };
 
 #define PC_Q35_COMPAT_1_4 \
-        PC_COMPAT_1_4, \
-        PC_Q35_COMPAT_1_5
+        PC_Q35_COMPAT_1_5, \
+        PC_COMPAT_1_4
 
 #define PC_Q35_1_4_MACHINE_OPTIONS \
     PC_Q35_1_6_MACHINE_OPTIONS, \
diff --git a/include/hw/i386/pc.h b/include/hw/i386/pc.h
index fb7d68d..d988b80 100644
--- a/include/hw/i386/pc.h
+++ b/include/hw/i386/pc.h
@@ -336,7 +336,6 @@ bool e820_get_entry(int, uint32_t, uint64_t *, uint64_t *);
         }
 
 #define PC_COMPAT_1_7 \
-        PC_COMPAT_2_0, \
         {\
             .driver   = TYPE_USB_DEVICE,\
             .property = "msos-desc",\
@@ -349,7 +348,6 @@ bool e820_get_entry(int, uint32_t, uint64_t *, uint64_t *);
         }
 
 #define PC_COMPAT_1_6 \
-        PC_COMPAT_1_7, \
         {\
             .driver   = "e1000",\
             .property = "mitigation",\
@@ -373,7 +371,6 @@ bool e820_get_entry(int, uint32_t, uint64_t *, uint64_t *);
         }
 
 #define PC_COMPAT_1_5 \
-        PC_COMPAT_1_6, \
         {\
             .driver   = "Conroe-" TYPE_X86_CPU,\
             .property = "model",\
@@ -417,7 +414,6 @@ bool e820_get_entry(int, uint32_t, uint64_t *, uint64_t *);
         }
 
 #define PC_COMPAT_1_4 \
-        PC_COMPAT_1_5, \
         {\
             .driver   = "scsi-hd",\
             .property = "discard_granularity",\